︠f4e78ecc-4f33-4b95-a347-bf7a838d6c1bs︠
%latex 
\noindent Exploration 1: The $3n+1$ Problem: If $n$ is odd, replace it by $3n+1$. If $n$ is even, divide it by 2. Repeat this cycle until an element is repeated

\bigskip 

\noindent (1) Find the length and terminating value for when \\
\indent $n =21$ \\
\indent $n =13$ \\
\indent $n =31$ \\
︡2286f12e-11e8-483d-8085-31c5ea58c42b︡{"file":{"filename":"/tmp/tmpsUPQjL.png","show":true,"text":null,"uuid":"1a3f1f13-570b-4e6c-b20a-ec4f67a7421f"},"once":false}︡{"done":true}︡
︠12175970-1abf-4640-bb4c-825cc02a0801s︠
# defining the 3n+1 alogrithm to generate a list and determine its length
def threeN(n):
    list = []
    while n not in list:
        if Mod(n,2) == 0: #test for even
            list.append(n)
            n = n/2
        else:            # if not even it is odd
            list.append(n)
            n = 3*n+1
    length = len(list)
    return (length, list)

# threeN(21);
# threeN(13);
# threeN(31);
# print
# print
%latex




\noindent The length and terminating value of the $3n+1$ algorithm for: \\
\indent n = 21 is 8 and 1 \\
\indent n = 13 is 10 and 1 \\
\indent n = 31 is 107 and 1
︡6fe05e7e-e49e-4fe0-ac7f-e8ddf4d0ee1c︡{"file":{"filename":"/tmp/tmpsgBHeg.png","show":true,"text":null,"uuid":"352b32f1-75df-4939-80ee-172326161555"},"once":false}︡{"done":true}︡
︠d2b142a4-ca43-48f5-84be-807cf0f04575si︠
TerminateTest = 10000
print "n  ","length","  termination value"
for i in range(0, TerminateTest):
    a = threeN(i)
print i,"  ", a[0],"        ", a[1][-1]  # Indent this row if you want to see all iterations
︡d8f0eea0-d0c7-4089-bb0e-73b2e4a67879︡{"stdout":"n   length   termination value\n"}︡{"stdout":"9999    92          1\n"}︡{"done":true}︡
︠8619a44b-43dd-4c3a-aa52-f95ee8520d2bs︠
%latex

\noindent (2) Based upon running multiple tests for increasing values of $n$, it appears as though this algorithm terminates at a value of 1 for all natural numbers $n$.
︡96d1dbd3-6be9-4979-aa71-e04ee08ba459︡{"file":{"filename":"/tmp/tmplsUjAg.png","show":true,"text":null,"uuid":"b5da3240-06c1-4070-a9ea-f8b22e5ef280"},"once":false}︡{"done":true}︡
︠532939ac-4fb1-4c13-9c87-61ecbf88ec20si︠
%latex
\noindent (3) Let $L(n)$ be the length of the algorithm for a starting value $n$. Assuming that the algorithm terminates, we want to show that if $n=8k+4$, then $L(n)=L(n+1)$. That is, we want to show that both $n = 8k+4$ and $n +1  = 8k+4$ have the same length. It is enough to show that if $n$ and $n+1$ are equal on the same iteration through this alorithm, then $L(n)=L(n+1)$. Notice, 
\begin{align*}
8k &+4 & 8k &+5 \\
4k &+2 & 24 k&+16 \\
2k &+1 & 12k &+8 \\
6k &+4 & 6k &+4
\end{align*}
and both $n$ and $n+1$ will generate the same set hereafter. Under the assumption that this algorithm terminates, $L(n)$ and $L(n+1)$ will be equal since the fourth elements generated are the same for both $n$ and $n+1$.
︡1e7e7e04-f440-4d55-a4b6-fccfb3b60427︡{"file":{"filename":"/tmp/tmpJI0Olr.png","show":true,"text":null,"uuid":"77a81d9d-d3cc-4fe7-bf7d-9f7cb483f367"},"once":false}︡{"done":true}︡
︠36cc4262-3ada-4b7a-8dc2-b6536d72f9a4si︠
%latex
\noindent (4) Let $L(n)$ be the length of the algorithm for a starting value $n$, as in the previous exercise. We want to show that, if $n=128k+28$ for some natural number $k$, then $L(n)= L(n+1)=L(n+2)$. This means that we must prove that $128k+28$, $128k+29$, and $128k+30$ all have the same length for the given algorithm. Proceeding through the algorithm with these three values, we can see that:
\begin{align*}
128k &+28 & 128k &+29 & 128k &+30 \\
64k &+14 & 384k &+88 & 64k &+15 \\
32k &+7 & 192k &+44 & 192k &+46 \\
96k &+22 & 96k &+22 & 96k &+23 \\
48k &+11 & 48k &+11 & 288k &+70 \\
144k &+34 & 144k &+34 & 144k &+35 \\
72k &+17 & 72k &+17 & 432k &+106 \\
216k &+52 & 216k &+52 & 216k &+53 \\
108k &+26 & 108k &+26 & 648k &+160 \\
54k &+13 & 54k &+13 & 324k &+80 \\
162k &+40 & 162k &+40 & 162k &+40
\end{align*}
Thus, all three patterns will generate the same set following the eleventh element for each pattern. Therefore, given that $L(n)$ terminates, $L(n)= L(n+1)=L(n+2)$ if $n=128k+28$.
︡9c04cb56-01a3-4251-b7c2-4b4bb435359f︡{"file":{"filename":"/tmp/tmpMdTNyi.png","show":true,"text":null,"uuid":"2230fa7d-74a5-4de6-9fe7-f17e43f0d920"},"once":false}︡{"done":true}︡
︠12cf94ad-f2db-4c21-acc7-11f7bc370b38si︠
%latex
\noindent (5) Some conditions for $n$ that will produce consecutive values of $n$ that have the same length (that is, $L(n)=L(n+1)$) include if:
$$n=16k+2$$
$$n=32k+20$$
$$n=40k+4$$
︡33e438c8-b310-4342-a95b-fa9101187367︡{"file":{"filename":"/tmp/tmpSQBtZw.png","show":true,"text":null,"uuid":"709dffc9-1029-4fc4-ac2d-52b6a7b8d966"},"once":false}︡{"done":true}︡
︠ef775689-d731-4982-bab9-a4cc4158b5c8i︠
%latex
\noindent (6) The function $L(n)$ and $T(n)$ are defined below.
︡3b27ab87-d8df-4640-b47d-80afbf938377︡{"file":{"filename":"/tmp/tmpVL0mhC.png","show":true,"text":null,"uuid":"b004b58f-e412-4828-8af7-3a917cdf5dad"},"once":false}︡{"done":true}︡
︠ad16ae0f-f524-48f1-b8f0-d743cbfe15f6s︠
# L(n) function.
def L(n):
    list = []
    while n not in list:
        if Mod(n,2) == 0: # test for even
            list.append(n)
            n = n/2
        else:            # if not even it is odd
            list.append(n)
            n = 3*n+1
    length = len(list)
    return length

# T(n) function.
def T(n):
    list = []
    while n not in list:
        if Mod(n,2) == 0: #test for even
            list.append(n)
            n = n/2
        else:            # if not even it is odd
            list.append(n)
            n = 3*n+1
    return list[-1]

print "n  ","L(n)","  T(n)"
for i in range(1, 101):
    print i, "  ",L(i),"   ", T(i)
︡6911c499-424c-45c8-b29a-983ea8ae32d9︡{"stdout":"n   L(n)   T(n)\n"}︡{"stdout":"1    3     2\n2    3     4\n3    8     1\n4    3     1\n5    6     1\n6    9     1\n7    17     1\n8    4     1\n9    20     1\n10    7     1\n11    15     1\n12    10     1\n13    10     1\n14    18     1\n15    18     1\n16    5     1\n17    13     1\n18    21     1\n19    21     1\n20    8     1\n21    8     1\n22    16     1\n23    16     1\n24    11     1\n25    24     1\n26    11     1\n27    112     1\n28    19     1\n29    19     1\n30    19     1\n31    107     1\n32    6     1\n33    27     1\n34    14     1\n35    14     1\n36    22     1\n37    22     1\n38    22     1\n39    35     1\n40    9     1\n41    110     1\n42    9     1\n43    30     1\n44    17     1\n45    17     1\n46    17     1\n47    105     1\n48    12     1\n49    25     1\n50    25     1\n51    25     1\n52    12     1\n53    12     1\n54    113     1\n55    113     1\n56    20     1\n57    33     1\n58    20     1\n59    33     1\n60    20     1\n61    20     1\n62    108     1\n63    108     1\n64    7     1\n65    28     1\n66    28     1\n67    28     1\n68    15     1\n69    15     1\n70    15     1\n71    103     1\n72    23     1\n73    116     1\n74    23     1\n75    15     1\n76    23     1\n77    23     1\n78    36     1\n79    36     1\n80    10     1\n81    23     1\n82    111     1\n83    111     1\n84    10     1\n85    10     1\n86    31     1\n87    31     1\n88    18     1\n89    31     1\n90    18     1\n91    93     1\n92    18     1\n93    18     1\n94    106     1\n95    106     1\n96    13     1\n97    119     1\n98    26     1\n99    26     1\n100    26     1\n"}︡{"done":true}︡
︠8708e62f-2a43-4387-a80c-a90d8c9b478b︠











